<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <title>Contact Detail</title>
    <style>
        input[readonly].transparent-background {
            background-color: white;
        }
    </style>
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron mt-5">
        <h2 class="text-center pb-3 font-weight-bold">THÔNG TIN LIÊN HỆ CHI TIẾT</h2>
        <form action="" id="contact-detail-form">
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-12 form-group row">
                    <div class="col-3 text-right">
                        <label for="inp-name" class="col-form-label ">Name</label>
                        <label class="col-form-label text-danger">(*)</label>
                    </div>
                    <div class="col-9">
                        <input type="text" class="form-control transparent-background" id="inp-name">
                    </div>
                </div>
            </div>
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-12 form-group row">
                    <div class="col-3 text-right">
                        <label for="inp-email" class="col-form-label ">Email</label>
                        <label class="col-form-label text-danger">(*)</label>
                    </div>
                    <div class="col-9">
                        <input type="email" class="form-control transparent-background" id="inp-email">
                    </div>
                </div>
            </div>
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-12 form-group row">
                    <div class="col-3 text-right">
                        <label for="txt-message" class="col-form-label ">Message</label>
                        <label class="col-form-label text-danger">(*)</label>
                    </div>
                    <div class="col-9">
                        <textarea name="" id="txt-message" class="form-control transparent-background" cols="30"
                            rows="5"></textarea>
                    </div>
                </div>
            </div>
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-12 form-group row">
                    <div class="col-3 text-right">
                        <label for="inp-date" class="col-form-label ">Ngày liên hệ</label>
                        <label class="col-form-label text-danger">(*)</label>
                    </div>
                    <div class="col-9">
                        <input type="text" class="form-control transparent-background" id="inp-date" readonly>
                    </div>
                </div>
            </div>
            <div class="row justify-content-center pl-5 pr-5">
                <div class="col-12 form-group row d-flex justify-content-end">
                    <div class="btn-group">
                        <button type="submit" class="btn btn-success ml-2 mr-1">Save data</button>
                        <button type="button" class="btn btn-primary ml-1 mr-2" id="btn-cancel">Cancel</button>
                    </div>
                </div>
            </div>
        </form>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
    const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    var gContact = {
        id: "",
        name: "",
        email: "",
        message: "",
        createDate: ""
    }
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    var gContactDetailFormElement = document.getElementById("contact-detail-form");
    var gCancelButtonElement = document.getElementById("btn-cancel");
    var gNameInputElement = document.getElementById("inp-name");
    var gEmailInputElement = document.getElementById("inp-email");
    var gMessageTextareaElement = document.getElementById("txt-message");
    var gCreateDateInputElement = document.getElementById("inp-date");

    gContactDetailFormElement.addEventListener("submit", function (paramEvent) {
        //Loại bỏ mặc định của submitform
        paramEvent.preventDefault();
        getDataContact(gContact);
        //Kiem tra du lieu
        var vDataValidated = validateDataContact(gContact);
        if (vDataValidated) {
            //goi Api
            var vXmlHttp = new XMLHttpRequest();
            callApiChangeDataContact(gContact, vXmlHttp);
            //Thong bao du lieu da duoc sua
            informContactData(vXmlHttp);
        }
    });

    gCancelButtonElement.addEventListener("click", function onBtnCancelClick() {
        backToListContactView();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        //Thu thap du lieu
        getDataOnPageLoading(gContact);
        //goiApi
        var vXmlHttp = new XMLHttpRequest();
        callApiGetContactById(gContact, vXmlHttp);
        //Hien thi contact len web
        loadContactToWeb(vXmlHttp);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function backToListContactView() {
        window.location.href = "listContact.html";
    }

    function getDateToday() {
        var vToday = new Date();
        var vDay = vToday.getDate();
        var vMonth = vToday.getMonth() + 1;
        var vYear = vToday.getFullYear();
        if (vDay < 10) {
            vDay = '0' + vDay;
        }
        if (vMonth < 10) {
            vMonth = '0' + vMonth;
        }
        vToday = vDay + '/' + vMonth + '/' + vYear;
        return vToday;
    }

    function ValidateEmail(paramEmail) {
        var vRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (paramEmail.match(vRegex)) {
            return true;
        }
        else
            return false;
    }

    function getDataOnPageLoading(paramContact) {
        // get data from query string
        var vUrlString = window.location.href; //đường đẫn gọi đến trang
        var vUrl = new URL(vUrlString);
        // get parameters
        paramContact.id = vUrl.searchParams.get("id");
    }

    function callApiGetContactById(paramContact, paramXmlHttp) {
        const vAPI_URL = gBASE_URL + "/contacts/";
        paramXmlHttp.open("GET", vAPI_URL + paramContact.id, true);
        paramXmlHttp.send();
    }

    function loadContactToWeb(paramXmlHttp) {
        paramXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK)
                if (this.status == gREQUEST_STATUS_OK) {
                    console.log(paramXmlHttp.responseText);
                    var vContactResponse = JSON.parse(paramXmlHttp.responseText);
                    //load data to innerHTML of elements
                    gNameInputElement.value = vContactResponse.name;
                    gEmailInputElement.value = vContactResponse.email;
                    gMessageTextareaElement.value = vContactResponse.message;
                    gCreateDateInputElement.value = vContactResponse.createDate;
                }
                else {
                    alert("Lấy thông tin liên hệ thất bại!");
                    backToListContactView();
                }
        }
    }

    function getDataContact(paramContact) {
        paramContact.name = gNameInputElement.value.trim();
        paramContact.email = gEmailInputElement.value.trim();
        paramContact.message = gMessageTextareaElement.value.trim();
        paramContact.createDate = getDateToday();
    }

    function validateDataContact(paramContact) {
        if (paramContact.name == "") {
            alert("Bạn chưa nhập tên!");
            return false;
        }
        if (paramContact.email == "") {
            alert("Bạn chưa nhập email!");
            return false;
        }
        if (ValidateEmail(paramContact.email) == false) {
            alert("Email sai định dạng!");
            return false;
        }
        if (paramContact.message == "") {
            alert("Bạn chưa nhập lời nhắn!");
            return false;
        }
        if (paramContact.message.length < 20) {
            alert("Lời nhắn của bạn quá ngắn!");
            return false;
        }
        return true;
    }

    function callApiChangeDataContact(paramContact, paramXmlHttpChangeContact) {
        const vAPI_URL = gBASE_URL + "/contacts/";
        paramXmlHttpChangeContact.open("PUT", vAPI_URL + paramContact.id, true);
        paramXmlHttpChangeContact.setRequestHeader("Content-Type", "application/json");
        paramXmlHttpChangeContact.send(JSON.stringify(paramContact));
    }

    function informContactData(paramXmlHttpChangeContact) {
        paramXmlHttpChangeContact.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK)
                if (this.status == gREQUEST_STATUS_OK) {
                    console.log(paramXmlHttpChangeContact.responseText);
                    alert("Sửa thông tin liên hệ thành công!");
                    backToListContactView();
                }
                else {
                    alert("Sửa thông tin liên hệ thất bại!");
                    backToListContactView();
                }
        }
    }
</script>

</html>